//
//  YHOWaterfallBuilder.m
//  RACTest
//
//  Created by lovingc2009 on 2018/5/30.
//  Copyright © 2018年 lovingc2009. All rights reserved.
//

#import "YHOWaterfallBuilder.h"
#import "calculateScale.h"
#import <CoreGraphics/CoreGraphics.h>

@implementation YHOWaterfallBuilder

+ (NSArray *)generateSizesWithScales:(NSArray<NSNumber *> *)input{
    NSInteger count = input.count;
    
    float arr[count];
    float *p = arr;
    
    [input enumerateObjectsUsingBlock:
     ^(NSNumber * _Nonnull obj,
       NSUInteger idx, BOOL * _Nonnull stop) {
         
        *(p + idx) = obj.floatValue;
    }];
    
    calculate_scale(arr, (int)count);
    
    NSMutableArray *result = [NSMutableArray arrayWithCapacity:count];
    for (int i=0; i<count; i++) {
        CGSize scaleSize = CGSizeMake(arr[i], arr[i]/[input[i] floatValue]);
        [result addObject:@(scaleSize)];
    }
    return result;
}

@end
